#include<iostream>
#include<vector>
using namespace std;

struct Point {
	unsigned counter;
	vector<short> points;

	Point() {
		counter = 0;
	}
};

Point ** graph;
unsigned N;

inline bool isPaw(unsigned point) {
	return (graph[point]->counter == 1);
}

bool isBunny(unsigned point) {
	int paws = 0;
	for(vector<short>::iterator it = graph[point]->points.begin(); it != graph[point]->points.end(); ++it) {
		if(isPaw(*it)) {
			paws++;
		} else
			return false;
	}
	return paws >= 4;
}

int main() {
	unsigned points;
	unsigned lines;
	while(cin >> points >> lines) {
		graph = new Point * [points];
		for (unsigned i = 0; i < points; i++) {
			graph[i] = new Point();
		}

		for (unsigned i = 0; i < lines; i++) {
			unsigned x, y;
			cin >> x >> y;
				graph[x-1]->points.push_back(y-1);
				graph[x-1]->counter++;
			
				graph[y-1]->points.push_back(y-1);
				graph[y-1]->counter++;
		}
	
		N = points;		

		bool found = false;
		for (unsigned i = 0; i < N; i++) {
			if(graph[i]->counter >= 4 && isBunny(i)) {
				cout << "YES" << endl;
				found = true;
				break;
			}
		}
		
		if (!found)
			cout << "NO" << endl;

		for (unsigned i = 0; i < points; i++) {
			delete graph[i];
		}
		delete [] graph;
	}

	return 0;
}



